#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import normalDate
import datumutilities
import textutilities
import sys
import re
import string
import sortieren
import gemeindekarteimysql
import baukontomysql
import optionen
import kontenplan
# import gesangbuchmysql
import os
import abkuerzungenmysql
import zuordnungenmysql

# Die bergeordnete Datei. Sie enthlt die Klassen und Funktionen
# die vom User-Interface aufgerufen werden. Ein CGI-Skript erzeugt
# z.B. jeweils adhoc eine Instanz z.B. von 

class GemeindekarteiBearbeiten:
    def __init__(self,MysqlDatenbank,Buchungsjahr,User="-",Optionen=None):
        self.Buchungsjahr = Buchungsjahr
        self.Gemeindekartei = gemeindekarteimysql.Gemeindekartei(MysqlDatenbank,Buchungsjahr)
        self.Optionen = self.Gemeindekartei.optionen
        self.Baukonto = baukontomysql.Baukonto(MysqlDatenbank,self.Buchungsjahr)
        # eigentlich wrde das Optionen-Objekt nicht mehr gebraucht, es ist jetzt in der
        # gemeindekartei-Instanz enthalten. => Gemeindekartei-Klasse umschreiben?
        self.User = User

   ## def __del__(self):
##        self.Gemeindekartei.verbindungBeenden()

    def abkuerzungBedeutung(self,abkuerzung):
        return self.Gemeindekartei.abkuerzungBedeutung(abkuerzung)

    def alleZugaenge(self,jahr=None):
        return self.Gemeindekartei.alleZugaenge(jahr)

    def alleAbgaenge(self,jahr=None):
        return self.Gemeindekartei.alleAbgaenge(jahr)

    def zugaengeSuchen(self,status,grund,jahr=None):
        return self.Gemeindekartei.zugaengeSuchen(status,grund,jahr)

    def abgaengeSuchen(self,status,grund,jahr=None):
        return self.Gemeindekartei.abgaengeSuchen(status,grund,jahr)

    def statusUebersicht(self):
        return self.Gemeindekartei.statusUebersicht()

    def loginProtokoll(self,User):
        self.Gemeindekartei.loginProtokoll(User)

    def serienbriefErstellen(self,user,vorlage,schluesselliste,alleSpenden="nein",auswahlliste=None):
        sbverzeichnis = self.Optionen.optionen["Serienbriefverzeichnis"]
        spendendict = None
        spendentest = vorlage.lower()[:7]
        if spendentest == "spenden":
            spendendict = self.Baukonto.spendenTabelleListe(schluesselliste,alleSpenden=alleSpenden,auswahlliste=auswahlliste)
            # auswahlliste schrnkt auf bestimmte Buchungsnummern ein - eigenlich nur relevant fr die Anzeige der Spendenquittung
            # fr einen einzelnen Spender mit "GemeindekarteiSerienbriefDirektanzeige".
        return self.Gemeindekartei.serienbriefErstellen(user,sbverzeichnis,vorlage,schluesselliste,spendendict)

    def serienbriefAusdruckenOpenOffice(self,liste):
        return self.Gemeindekartei.serienbriefAusdruckenOpenOffice(liste)

    def tabelleExportierenCSV(self,user,trenner="\t",schluesselliste=None):
        sbverzeichnis = self.Optionen.optionen["Serienbriefverzeichnis"]
        return self.Gemeindekartei.tabelleExportierenCSV(user=user,verzeichnis=sbverzeichnis,trenner=trenner,schluesselliste=schluesselliste)

    def alleVorlagen(self,spenden="nein"):
        """Vorlagendateien fr Serienbriefe"""
        return self.Optionen.alleVorlagen(spenden=spenden)

    def alleSicherungen(self):
        """Alle Sicherungsdateien der aktuellen Datenbank aus dem Sicherungsverzeichnis."""
        return self.Optionen.alleSicherungen()

    def serienbriefVerzeichnisUser(self):
        # Achtung, alte Version:
        dir = self.Optionen.optionen["Serienbriefverzeichnis"]
        # dir = os.getcwd()
        # Die User-Verzeichnisse kommen direkt ins Bezirksreiter-Verzeichnis
        # und werden auf diese Weise beim Neustart immer schn gelscht.
        # Bei der Mehrbenutzer-Version mu das anders werden.
        # Geht aber noch nicht richtig.
        return self.Gemeindekartei.serienbriefVerzeichnis(dir,self.User)

    def serienbriefVerzeichnis(self):
        return self.Optionen.optionen["Serienbriefverzeichnis"]

    def eintragSuchen(self,suchdict):
        return self.Gemeindekartei.eintragSuchfunktion(suchdict)

    def primaerschluessel(self):
        return self.Gemeindekartei.primaerschluessel()
    
    def schluesselSuchen(self,schluessel,eintrag_pruefen="nein"):
        return self.Gemeindekartei.schluesselSuchen(schluessel,eintrag_pruefen=eintrag_pruefen)

    def eintragVergleichen(self,schluessel,vergleichdict):
        return self.Gemeindekartei.eintragVergleichen(schluessel,vergleichdict)

    def sortierteListe(self,sortierkategorie):
        return self.Gemeindekartei.sortierteListe(sortierkategorie)

    def ungeprueftListe(self):
        return self.Gemeindekartei.ungeprueftListe()
 
    def geburtstageGemeindebrief(self,ab_alter=65,nur_aktive="ja",Anrede_verwenden="ja"):
        return self.Gemeindekartei.geburtstageGemeindebrief(ab_alter,nur_aktive,Anrede_verwenden)

    def jahresListe(self,kategorie):
        return self.Gemeindekartei.JahresListe(kategorie)

    def alleSpalten(self):
        return self.Gemeindekartei.Spaltennamen

    def spaltenBeschreibung(self):
        return self.Gemeindekartei.Spaltenbeschreibung

    def neuerEintrag(self,neudict):
        return self.Gemeindekartei.neuerEintrag(neudict)

    def eintragLoeschen(self,schluesselwert):
        return self.Gemeindekartei.eintragLoeschen(schluesselwert=schluesselwert)

    def eintragAendern(self,aenderungsdict,schluessel):
        self.Gemeindekartei.eintragAendern(aenderungsdict=aenderungsdict,schluessel=schluessel)

    def sichernCSV(self):
        self.Gemeindekartei.sichernCSV()

    def sichernMysqldump(self,Datenbank,ruecksichern="nein",rueckdatei=""):
        # print "Datenbank",Datenbank,"Optionen",self.Optionen.optionen
        return self.Gemeindekartei.sichernMysqldump(Datenbank,self.Optionen.optionen["Sicherungsverzeichnis"],self.Optionen.optionen["Datenbankverzeichnis"],ruecksichern,rueckdatei)

    def holeLeerenEintrag(self):
        return self.Gemeindekartei.holeLeerenEintrag()

    def tabelleRuecksichern(self):
        # Was ist das fr eine Funktion???
        self.Gemeindekartei.tabelleRuecksichern()

    def csvDateiImportieren(self):
        # bernimmt das Tabulatorzeichen als voreingestellten Trenner
        return self.Gemeindekartei.csvDateiImportieren(self.Optionen.optionen["Importdatei"])

    def sicherungsdatei(self):
        # alte Funktion, ungebraucht
        return self.Gemeindekartei.sicherungsdatei()

    def selectBefehlDirekt(self,befehl,nurselect="ja"):
        return self.Gemeindekartei.selectBefehlDirekt(befehl,nurselect=nurselect)   

    def emailSenden(self,text,liste,subject="Nachricht",absender="test@test"):
        return self.Gemeindekartei.emailSenden(text=text,liste=liste,subject=subject,absender=absender)

    def timenow(self):
        return self.Gemeindekartei.timenow()

    def spendername(self,schluessel,alleDaten="nein"):
        return self.Gemeindekartei.spendername(schluessel=schluessel,alleDaten=alleDaten)

    def alleBezirkeKonferenz(self,k):
        return self.Gemeindekartei.alleBezirkeKonferenz(k)

    def __getattr__(self,func,*args,**kwargs):
        # fr alle nicht extra definierten:
        return getattr(self.Gemeindekartei,func,*args,**kwargs)

##class GesangbuchBearbeiten:
##    def __init__(self,MysqlDatenbank):
##        self.Gesangbuch = gesangbuchmysql.Gesangbuch(MysqlDatenbank)

##    def alleSpalten(self):
##        return self.Gesangbuch.Spaltennamen

##    def neuerEintrag(self,neudict):
##        return self.Gesangbuch.neuerEintrag(neudict)

##    def eintragSuchen(self,suchdict):
##        return self.Gesangbuch.eintragSuchfunktion(suchdict)

##    def primaerschluessel(self):
##        return self.Gesangbuch.primaerschluessel()
    
##    def schluesselSuchen(self,schluessel):
##        return self.Gesangbuch.schluesselSuchen(schluessel)

##    def schluesselListeSuchen(self,schluesselliste,sortierkategorie="Titel"):
##        return self.Gesangbuch.schluesselListeSuchen(schluesselliste,sortierkategorie=sortierkategorie)

##    def eintragVergleichen(self,schluessel,vergleichdict):
##        return self.Gesangbuch.eintragVergleichen(schluessel,vergleichdict)

##    def sortierteListe(self,sortierkategorie):
##        return self.Gesangbuch.sortierteListe(sortierkategorie)

class AbkuerzungenBearbeiten:
    def __init__(self,MysqlDatenbank,Buchungsjahr):
        self.Gemeindekartei = gemeindekarteimysql.Gemeindekartei(MysqlDatenbank,Buchungsjahr)
        # Das Abkuerzungen-Objekt braucht fr Neueintrge/nderungen Zugriff auf die
        # Gemeindekartei, das Gemeindekartei-Objekt darf aber nicht im Konstruktor
        # von Abkuerzungen erzeugt werden => sonst zyklische Abhngigkeit, denn das
        # Gemeindekartei-Objekt enthlt seinerseits ein Abkrzungen-Objekt!
        self.Abkuerzungen = abkuerzungenmysql.Abkuerzungen(MysqlDatenbank,Buchungsjahr,self.Gemeindekartei)

    def alleSpalten(self):
        return self.Abkuerzungen.Spaltennamen

    def alleAbkuerzungenGemeindekartei(self):
        return self.Abkuerzungen.alleAbkuerzungenGemeindekartei()

    def eintragAendern(self,aenderungsdict,schluessel):
        return self.Abkuerzungen.eintragAendern(aenderungsdict=aenderungsdict, schluessel=schluessel)

    def neuerEintrag(self,neudict):
        return self.Abkuerzungen.neuerEintrag(neudict)

    def eintragSuchen(self,suchdict):
        return self.Abkuerzungen.eintragSuchfunktion(suchdict)

    def holeLeerenEintrag(self):
        return self.Abkuerzungen.holeLeerenEintrag()

    def primaerschluessel(self):
        return self.Abkuerzungen.primaerschluessel()

    def eintragLoeschen(self,schluessel):
        return self.Abkuerzungen.eintragLoeschen(schluesselwert=schluessel)
    
    def schluesselSuchen(self,schluessel):
        return self.Abkuerzungen.schluesselSuchen(schluessel)

    def schluesselListeSuchen(self,schluesselliste,sortierkategorie="Titel"):
        return self.Abkuerzungen.schluesselListeSuchen(schluesselliste,sortierkategorie=sortierkategorie)

    def eintragVergleichen(self,schluessel,vergleichdict):
        return self.Abkuerzungen.eintragVergleichen(schluessel,vergleichdict)

    def sortierteListe(self,sortierkategorie):
        return self.Abkuerzungen.sortierteListe(sortierkategorie)

class ZuordnungenBearbeiten:
    def __init__(self,MysqlDatenbank,buchungsjahr):
        self.zuordnungen = zuordnungenmysql.Zuordnungen(MysqlDatenbank,buchungsjahr)

    def __getattr__(self,func,*args,**kwargs):
        return getattr(self.zuordnungen,func,*args,**kwargs)

    def alleSpalten(self):
        return self.zuordnungen.Spaltennamen


        

class BaukontoBearbeiten:
    def __init__(self,MysqlDatenbank,buchungsjahr):
        self.buchungsjahr = buchungsjahr
        self.Gemeindekartei = gemeindekarteimysql.Gemeindekartei(MysqlDatenbank,self.buchungsjahr)
        # Die Gemeindekartei wird fr die Spendenverwaltung gebraucht.
        self.Baukonto = baukontomysql.Baukonto(MysqlDatenbank,self.buchungsjahr)
        self.Optionen = self.Baukonto.optionen

   ## def __del__(self):
##        self.Gemeindekartei.verbindungBeenden()
##        self.Baukonto.verbindungBeenden()
##     *** bringt das Durcheinander? ***

    def spendenquittungRegistrieren(self,buchungsliste):
        return self.Baukonto.spendenquittungRegistrieren(buchungsliste)
        

    def inVorlagenKopieren(self,schluessel):
        return self.Baukonto.inVorlagenKopieren(schluessel)

    def inVorlagenLoeschen(self,schluessel):
        self.Baukonto.inVorlagenLoeschen(schluessel)

    def inVorlagenHolen(self,schluessel):
        return self.Baukonto.inVorlagenHolen(schluessel)

    def alleVorlagenHolen(self):
        return self.Baukonto.alleVorlagenHolen()

    def letzterMonatsbeitrag(self,schluessel,sicherheitsloeschen="ja"):
        return self.Baukonto.letzterMonatsbeitrag(schluessel,sicherheitsloeschen)

    def eintragSuchen(self,suchdict):
        return self.Baukonto.eintragSuchfunktion(suchdict)    

    def primaerschluessel(self):
        return self.Baukonto.primaerschluessel()

    def schluesselSuchen(self,schluessel):
        return self.Baukonto.schluesselSuchen(schluessel)

    def eintragVergleichen(self,schluessel,vergleichdict):
        # funktioniert nur mit dem Primrschlssel "Belegnummer"!
        return self.Baukonto.eintragVergleichen(schluessel,vergleichdict)

    def summeSollHaben(self,kontonummer,mitStornos="ja",mitKontonummer="ja",grundstueck=None,gemeinde=None,wformat="nein",mitVorzeichen="ja"):
        return self.Baukonto.summeSollHaben(kontonummer,mitStornos=mitStornos,mitKontonummer=mitKontonummer,grundstueck=grundstueck,gemeinde=gemeinde,wformat=wformat,mitVorzeichen=mitVorzeichen)

    def summeSollHabenAlle(self,mitStornos="ja",mitKontonummer="ja",liste=None):
        return self.Baukonto.summeSollHabenAlle(mitStornos,mitKontonummer,liste)

    def summeSollHabenAlleHauptkonten(self,mitStornos="ja",mitKontonummer="ja"):
        return self.Baukonto.summmeSollHabenAlleHauptkonten(mitStornos=mitStornos,mitKontonummer=mitKontonummer)

    def summeSollHabenUnterkonten(self,Hauptkonto,mitStornos="ja",mitKontonummer="ja"):
        return self.Baukonto.summeSollHabenUnterkonten(Hauptkonto,mitStornos,mitKontonummer)

    def sortierteListe(self,sortierkategorie,where=""):
        return self.Baukonto.sortierteListe(sortierkategorie,where=where)
 
    def jahresListe(self,kategorie):
        return self.Baukonto.JahresListe(kategorie)

    def alleKontenPruefen(self,schluessel,sortierkategorie="Belegnummer",grundstueck=None,gemeinde=None):
        return self.Baukonto.alleKontenPruefen(schluessel,sortierkategorie,grundstueck,gemeinde)

    def alleSpalten(self):
        return self.Baukonto.Spaltennamen

    def spaltenBeschreibung(self):
        return self.Baukonto.Spaltenbeschreibung

    def holeLeerenEintrag(self):
        return self.Baukonto.holeLeerenEintrag()

    def neuerEintrag(self,neudict):
        return self.Baukonto.neuerEintrag(neudict)

    def eintragLoeschen(self,schluesselwert):
        return self.Baukonto.eintragLoeschen(schluesselwert)

    def eintragAendern(self,aenderungsdict,schluessel):
        self.Baukonto.eintragAendern(aenderungsdict=aenderungsdict,schluessel=schluessel)

    def storno(self,schluessel):
        return self.Baukonto.storno(schluessel)

    def summeBaukonto(self):
        return self.Baukonto.summeBaukonto()

    def summeBaukasseBar(self):
        return self.Baukonto.summeBaukasseBar()

    def sichernCSV(self):
        self.Baukonto.sichernCSV()

    def tabelleRuecksichern(self):
        self.Baukonto.tabelleRuecksichern()

    def sicherungsdatei(self):
        return self.Baukonto.sicherungsdatei()

    def tabuschluesselEntfernen(self,dict):
        return self.Baukonto.tabuschluesselEntfernen(dict)

    def spendername(self,schluessel):
        return self.Baukonto.spendername(schluessel)

    def betragsartPruefen(self,pruefdict):
        return self.Baukonto.buchungPruefen(pruefdict)

    def alleSpender(self):
        return self.Baukonto.alleSpender()

    def spendenTabelle(self,MZ,alleSpenden):
        return self.Baukonto.spendenTabelle(MZ,alleSpenden)

class KontenplanBearbeiten:
    
    def __init__(self,MysqlDatenbank,Buchungsjahr):
        self.Kontenplan = kontenplan.BaukontoKontenplan(MysqlDatenbank,Buchungsjahr)
        self.Buchungsjahr = Buchungsjahr
        self.Baukonto = baukontomysql.Baukonto(MysqlDatenbank,self.Buchungsjahr)

    def sortierteListe(self,kategorie):
        return self.Kontenplan.sortierteListe(kategorie)

    def schluesselSuchen(self,schluessel):
        return self.Kontenplan.schluesselSuchen(schluessel)

    def eintragVergleichen(self,schluessel,vergleichdict):
        return self.Kontenplan.eintragVergleichen(schluessel,vergleichdict)

    def alleKontenPruefen(self,schluessel):
        return self.Baukonto.alleKontenPruefen(schluessel)

    def eintragAendern(self,aenderungsdict,schluessel):
        return self.Kontenplan.eintragAendern(aenderungsdict=aenderungsdict,schluessel=schluessel)

    def alleUnterkonten(self,Hauptkontonummer,mitHauptkonto="ja"):
        return self.Kontenplan.alleUnterkonten(Hauptkontonummer,mitHauptkonto)

    def eintragLoeschen(self,schluessel):
        if self.Baukonto.alleKontenPruefen(schluessel):
            # Schon eine Buchung auf das Konto?
            print "Achtung, Buchung vorhanden, konnte nicht lschen!"
            return 0
        else:
            self.Kontenplan.eintragLoeschen(schluesselwert=schluessel)
            return 1
        
    def neuerEintrag(self,neudict):
        primaerschluessel = self.Kontenplan.primaerschluessel()
        temp = self.Kontenplan.neuerEintrag(neudict,primaerschluessel,neudict[primaerschluessel])
        if temp == 0:
            return (0,0)
        else:
            return (neudict[primaerschluessel], self.Kontenplan.schluesselSuchen(neudict[primaerschluessel]))

    def holeLeerenEintrag(self):
        return self.Kontenplan.holeLeerenEintrag()

    def alleSpalten(self):
        return self.Kontenplan.Spaltennamen

class OptionenBearbeiten:

    def __init__(self,MysqlDatenbank,Buchungsjahr):
        self.Optionen = optionen.Optionen(MysqlDatenbank,Buchungsjahr)
        self.Buchungsjahr = Buchungsjahr
        self.Optionswerte = self.Optionen.optionen

    def alleSpalten(self):
        return self.Optionen.Spaltennamen

    def schluesselSuchen(self):
        return self.Optionen.schluesselSuchen(self.Buchungsjahr)

    def eintragVergleichen(self,vergleichdict):
        return self.Optionen.eintragVergleichen(vergleichdict=vergleichdict)

    def eintragAendern(self,aenderungsdict,Buchungsjahr=None):
        if Buchungsjahr is None:
            Buchungsjahr = self.Buchungsjahr
        return self.Optionen.eintragAendern(aenderungsdict,Buchungsjahr)

    def jetztHolen(self):
        return self.Optionen.jetztHolen()

    def jetztSetzen(self,wert):
        return self.Optionen.jetztSetzen(wert)

    def neueDatenbankRechte(self,neueDatenbank,admin_passwort,mysql_passwort="",user="root"):
        return self.Optionen.neueDatenbankRechte(neueDatenbank=neueDatenbank,admin_passwort=admin_passwort,mysql_passwort=mysql_passwort,user=user)

    def neueDatenbank(self,neueDatenbank,kopieren="nein"):
        return self.Optionen.neueDatenbank(neueDatenbank,kopieren=kopieren)

    def neuesBuchungsjahr(self):
        return self.Optionen.neuesBuchungsjahr()

    def updateInfo(self):
        return self.Optionen.updateInfo()

    def geschmacksrichtung_bestimmen(self):
        return self.Optionen.geschmacksrichtung_bestimmen()
        
    
        
    

    
    
    
    
