#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
from types import *
import textutilities
import sys
import re
import string
import sortieren
import cgi
import urllib
import sortieren
import verwaltungMainServer

class HtmlUtilities:

    def __init__(self):               
        self.kontonameWeb = re.compile(r"(\d\d\d\d?\d?\d?)\:")
        # fr die Umwandlung der Kontennamen
        self.sortierwerkzeug = sortieren.Sortieren()

    def kontennamenUmwandeln(self,dictarray):
        return self.sortierwerkzeug.mapAll(dictarray,funktion=self.kontennamenUmwandelnHilfsfunktion)

    def kontennamenUmwandelnHilfsfunktion(self, wert):
        """Wandelt die Kontennamen um, die in der Form
        Kontonummer: Kontenname (z.B. 302: Kollekten) ankommen.
        Knnte evtl. auch nach baukontoweb."""
        wert = "%s" % wert
        # *** Umwandlung in String, wichtig, weil der Primrschlssel Integer ist! ***
        mobj = self.kontonameWeb.search(wert)
        if mobj is not None:
            return mobj.group(1)
        else:
            return wert

    def abkuerzungenZurueck(self,dict,kategorien):
        neudict = {}
        neudict.update(dict)
        for d in dict.keys():
            if d in kategorien:
                try:
                    neudict[d] = ((dict[d].split(":"))[0]).strip()
                except:
                    pass
        return neudict

    def abkuerzungenZurueck_emkadressen_neu(self,dict):
        kategorien = ("Status1","Status2","Status3","Status4","Status5","Distrikt")
        return self.abkuerzungenZurueck(dict,kategorien)

    def matrixAufspalten(self,matrix):
        """Macht z.B. aus einer zweispaltigen eine vierspaltige Matrix. Wichtig
        z.B. fr Eingabeformulare."""
        neuematrix = []
        anzahllinks = (len(matrix)+1)/2 # alles Integer s.u.!
        # Beachte das "+1" bei fnf Zeilen mssen links drei stehen usw.
        laengematrix = len(matrix)
        zeilenlaengematrix = len(matrix[0])
        # Achtung, so angegeben wird automatisch mit Integern gerechnet!
        leerezeile = []
        for i in range(zeilenlaengematrix*2):
            leerezeile.append(" ")
            # Ein Space, weil Netscape das Feld sonst nicht anzeigt, wenn
            # man mit HTML-Tabellen arbeitet.
        for i in range(anzahllinks):
            neuezeile = leerezeile[:]
            # echte Kopie...
            for j in range(zeilenlaengematrix):
                neuezeile[j] = matrix[i][j]
                if (i+anzahllinks)<laengematrix:
                    # rechts steht u.U. nicht so viel wie links
                    neuezeile[j+zeilenlaengematrix] = matrix[i+anzahllinks][j]
            neuematrix.append(neuezeile)
        return neuematrix            

    def tabelleMitInhalt(self,matrix,border="0",weite="100%",fontsize="-1",cellpadding="0",cellspacing="0",aufspalten="nein",colgroups=[],farbe="#eeeeff"):
        # Es mu eine 2-dimensionale Matrix bergeben werden, notfalls eine leere
        # Achtung, es erzeugt eine "Rohform", kein HTML-Escape!
        if farbe != "":
            farbe = """bgcolor="%s" """ % farbe            
        # cellpadding,cellspacing,border = "0","0","1"
        if aufspalten == "ja":
            matrix = self.matrixAufspalten(matrix) 
        tabellenstring = """
        <table BORDER="%s" WIDTH="%s" cellpadding=%s cellspacing=%s >
        """ % (border,weite,cellpadding,cellspacing)
        ##if (colgroups) and aufspalten == "nein":
##            # nicht aufzuspaltende Matrizen knnen mit vorgegebener Spaltenbreite usw. ausgegeben werden:
##            tabellenstring += "<colgroup>"
##            for i in colgroups:
##                tabellenstring += """<col %s>""" % i
##            tabellenstring += "</colgroup>" 
        for zeile in range(len(matrix)):
            tabellenstring += "\n<tr>"
            for spaltenwert in matrix[zeile]:
                # print "spaltenwert",spaltenwert
                if zeile % 2 == 0:
                    tabellenstring += """<td %s> <font size=%s> %s</font></td>\n""" % (farbe,fontsize,spaltenwert)
                else:
                    tabellenstring += "<td><font size=%s> %s</font></td>\n" % (fontsize,spaltenwert)
                
            tabellenstring += "</tr>\n"
        tabellenstring += "</table>"
        return tabellenstring

    
    def eingabeFormularAusgeben(self,felderliste,skript,hidden=None,submit="Abschicken",vierspaltig="ja",submit2="",border=0,farbe="#eeeeff",passwortfelder=[],textareafelder=[]):
        matrix = []        
        ## wenn Feldlnge = 2, dann sollen vorgegebene Werte in den "value"-Wert
        ## eingesetzt werden
        ## hidden mu als Liste/Tupel von Liste/Tupel bergeben werden.  
        for wert in felderliste:
            if type(wert) is StringType:
                if wert in passwortfelder:
                    temp = "<input type=password name=%s size=30/>" % wert
                elif wert in textareafelder:
                    temp = "<textarea name=%s rows=20 cols=60></textarea>" % wert
                else:
                    temp = "<input type=text name=%s size=30/>" % wert
                matrix.append((wert,temp))
            elif (type(wert) is ListType) or (type(wert) is TupleType):
                if (len(wert) > 1) and (wert[0]=="Optionen"):
                    # Auswahllisten einbauen (Drop-Down-Format, also size=1)
                    temp = """<select name="%s" size=1>""" % wert[1]
                    for option in wert[2]:
                        if len(wert) == 4 and option == wert[3]:
                            # Prfung auf vorselektierte Werte. Zuerst wird die
                            # Lnge geprft, damit es keinen "index out of range" gibt.
                            temp += """<option selected> %s""" % option
                        else:
                            temp += """<option> %s""" % option
                    temp += """</select>"""
                    matrix.append((wert[1],temp))
                else:
                    if wert[0] in textareafelder:
                        matrix.append((wert[0],"""<textarea name=%s rows=20 cols=60></textarea>""" % wert[0]))
                    else:
                        matrix.append((wert[0],"""<input type=text name=%s value="%s" size=30/>""" % (wert[0],wert[1])))
        htmlstring = self.tabelleMitInhalt(matrix,aufspalten=vierspaltig,border=border,farbe=farbe)
        hiddenstring = ""
        if hidden is not None:
            for i in hidden:
                hiddenstring += "<input type=hidden name=%s value=%s />" % i
        if submit2 != "":
            submit2 = """<input type=submit  name="submitbutton" value="%s" />""" % submit2
        return """
        <form action = %(skript)s %(post)s>
        %(htmlstring)s
        <input type=submit  name="submitbutton" value="%(submit)s" />
        %(submit2)s
        %(hiddenstring)s
        </form>
        """ % {"skript": skript,"htmlstring": htmlstring,"submit": submit, "submit2": submit2, "hiddenstring": hiddenstring, "post": verwaltungMainServer.POST}

    def smartlink(self,url,dict,linktext):
        # Es soll immer ein Dictionary bergeben werden.
        htmlstring = """<a href = "%s?""" % url
        for i in dict.keys():
            htmlstring += """%s=%s&""" % (i,urllib.quote_plus(dict[i]))
        htmlstring = htmlstring[:-1] + """">%s</a>""" % linktext
        # Das letzte "&" wird abgeschnitten, deshalb [:-1]
        return htmlstring

    def emaillink(self,liste,linktext):
        """Erzeugt eine E-Mail-Liste als Link."""
        text = ""
        for l in liste:
            text += """ %s,""" % urllib.quote_plus(l)
        text = text[:-1] # letztes Komma weg
        return """<a href="mailto: %s">%s</a>""" % (text,linktext)

    

    
