#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import htmlutilities
import gemeindekarteiweb
import optionen
import update
import os
import sys
import verwaltungMainServer


primaerkartei = 'Buchungsjahr'

class OptionenWeb (gemeindekarteiweb.GemeindeverwaltungWeb):
    """Achtung, einige Funktionen bernehmen andere Parameter als z.B. die Klasse GemeindekarteiWeb!!"""
    
    def __init__(self,MysqlDatenbank,dictarray=[{"dummy": "dummy"}],schaltzentrale="",alleSpalten=[],schluessel=None,datumumwandeln="ja"):
        """Eine HTML-Klasse fr verschiedene Zwecke. Lt sich auch ohne Dictarray initialisieren."""
        gemeindekarteiweb.GemeindeverwaltungWeb.__init__(self,dictarray,schaltzentrale,alleSpalten,schluessel)
        self.optionsfelder = {}

    def vorlagenAnzeigen(self,liste):
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        matrix = []
        for i in liste:
            #templiste = [i]
            # Achtung, Test: # nur noch das frhere "EinzelDirekt" bleibt.
            # templiste.append(self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': i, 'Aktion': 'GemeindekarteiSerienbriefDurchfuehren'}, "Serienbriefe"))
            templiste = [self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': i, 'Aktion': 'GemeindekarteiSerienbriefDirektanzeige'}, "%s" % i)]
            matrix.append(templiste)            
        return self.htmlwerkzeug.tabelleMitInhalt(matrix,border="1", weite="60%",aufspalten="nein")

    def vorlagenAnzeigenBearbeitung(self,liste,aktion):
        aktion = aktion
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        matrix = []
        for i in liste:
            templiste = [self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': i, 'Aktion': aktion}, "%s" % i)]
            templiste.append("&nbsp;") # es mssen mind. zwei Spalten sein.
            matrix.append(templiste)            
        return self.htmlwerkzeug.tabelleMitInhalt(matrix,border="1", weite="60%",aufspalten="nein")

    def spendenVorlagenAnzeigen(self,liste):
        return self.vorlagenAnzeigenBearbeitung(liste,"BaukontoSpendenquittungDirektanzeige")

    def spendenVorlagenAnzeigenBearbeiten(self,liste):
        return self.vorlagenAnzeigenBearbeitung(liste,"BaukontoSpendenquittungBearbeiten")

    def serienbriefVorlagenAnzeigen(self,liste):
        return self.vorlagenAnzeigenBearbeitung(liste,"GemeindekarteiVorlageBearbeiten")

    def loginsAnzeigen(self,listoflists):
        """Zeigt die mglichen Datenbank/Buchungsjahr-Kombinationen zum Login an."""
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        matrix = []
        text = ""
        if verwaltungMainServer.DEMOVERSION:
            text += """<H3>Die Datenbank "musterkartei" zeigt die Verwaltung nach dem Diensthandbuch der Evangelisch-methodistischen Kirche, die Datenbank "testkartei" eine allgemeine Ausfhrung mit einfacher Buchhaltung, z.B. fr die Landeskirche, andere Freikirchen oder Gemeinschaften. Die Datenbank "eibenstock_test" ist die Testversion einer Online-Masterdatenbank fr das Adressbuch der EmK Deutschland. Benutzername fr alle: "Onkel_Otto". Pawort fr alle: "12345".</H3><p><H3>Die Formularvorlagen fr Patenscheine, Spendenquittungen usw. sind nur Beispiele und knnen bei Installation auf dem eigenen Rechner beliebig angepat werden.</H3><p><H3>Die Datenbank "eibenstock" ist fr interne Testzwecke reserviert.</H3><p>"""
        text += """<H3>Bitte aktivieren Sie in Ihrem Browser die "Cookies" und whlen Sie Datenbank und Buchungsjahr zum Login:</H3><p>"""
        for login in listoflists:
            linktext = """Datenbank %s, Buchungsjahr %s""" % (login[0],login[1])
            matrix.append([self.htmlwerkzeug.smartlink(self.schaltzentrale,{"Aktion": "CookieGesetzt", "Datenbank": login[0], "Buchungsjahr": login[1]},linktext),""])
            # am Schlu immer ein leeres Feld, denn tabelleMitInhalt verarbeitet nur zweidimensionale Matrizen.
        text += self.htmlwerkzeug.tabelleMitInhalt(matrix,border="1", weite="80%",aufspalten="nein")
        return text

    def versionsinfoAnzeigen(self,dictofdicts,gui=0):
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        updatewerkzeug = update.UniversalUpdate()
        matrix = []
        matrix.append(["""<b>bisherige Version</b>""", """Nummer: %s""" % dictofdicts["alt"]["versionsnummer"]])
        matrix.append(["""<b>Version auf der Bezirksreiter-Homepage</b>""", """Nummer: %s""" % dictofdicts["update"]["versionsnummer"]])
        matrix.append(["""<b>Empfehlung der Versionsverwaltung</b>""", "%s" % dictofdicts["empfehlungen"]["update_noetig"]])
        matrix.append(["""<b>Besondere Hinweise</b>""", "%s" % dictofdicts["empfehlungen"]["hinweise"]])
        text = self.htmlwerkzeug.tabelleMitInhalt(matrix,border="1", weite="80%",aufspalten="nein")
        erklaerung = """<p><H3>Fr ein Update bitte:</H3>
<li><b>\"weiter zum Update\"</b> whlen.</li>
<li>Dafr sorgen, da eine <b>Internet-Verbindung</b> besteht bzw. bestehen bleibt.</li>
        """ 
        if sys.platform[:3] != "win" and not gui:
            # Das GUI-Update unter Linux startet selbstndig.
            erklaerung += """<li>Starten Sie dann das Programm update.py aus dem Verzeichnis <b>%s %s</b></li>""" % (os.path.normpath(updatewerkzeug.updateverzeichnis),updatewerkzeug.startmethode)
        # Achtung, der obige Text ist noch fr Windows zu ndern! => hier kann das Updateprogramm
        # automatisch in einem Eingabefenster starten. => Erledigt!
        smartlink1 = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'Aktion': 'UpdateStarten'}, "weiter zum Update")
        smartlink2 = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'Aktion': 'LeereSeite'}, "kein Update")
        # return """<p>%s%s""" % (text,erklaerung)
        zusatz = ""
        # zusatz = """<p><H3>Achtung nach Update, Wiederherstellen oder Neuinstallation: evtl. ist anschlieend vor dem Neustart des Bezirksreiters eine Wartezeit von 2-3 Minuten erforderlich(zur sog. "Socket-Freigabe")!"""
        return """<p>%s%s<p>%s<p><H3>%s</H3>%s""" % (text,erklaerung,smartlink1,smartlink2,zusatz)
    
       

    def sicherungenAnzeigen(self,liste):
        string = ""
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        for i in liste:
            string += self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': i, 'Aktion': 'GemeindekarteiRuecksichernDurchfuehren'},i)
            string += "<br>\n"
        return string 
        
    def aenderungsformular(self,aktion="OptionenAenderungenTesten"):
        return gemeindekarteiweb.GemeindeverwaltungWeb.aenderungsformular(self,optionsfelder=self.optionsfelder,aktion=aktion,skript=self.schaltzentrale,submit="Neueintrge/nderungen prfen")

    def aenderungsvergleich(self):
        gemeindekarteiweb.GemeindeverwaltungWeb.aenderungsvergleich(self,"OptionenAenderungenDurchfuehren","OptionenAenderungsformular")
