#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import htmlutilities
import string
import datumutilities
import cgi
import urllib
try:
   import Cookie
except:
   pass
import sys
import os
#import gemeindekarteiweb
#import baukontoweb
import re
import verwaltungMainServer
import state

class verwaltungUtilities:
   def __init__(self):
      self.datumsform = re.compile(r"(([\d?][\d?])\.([\d?][\d?])\.([\d?][\d?][\d?][\d?]))")
      self.mzform = re.compile(r"MZ(\d?\d?\d?\d?\d?\d)")

   def formulardatenUmwandeln(self,cgiformular):
      formdict = {}
      mzliste = []
      for i in cgiformular.keys():
         #print "\nhier\n: ",i
         # Abbildung der restlichen CGI-Formulardaten - auer "Aktion"
         # auf ein Dictionary
         mobj = self.mzform.match(i)
         if mobj:
            mzliste.append(mobj.group(1))
            # wir haben eine MZ aus einer Auswahlliste gefunden - nchster Key!
            continue
         if (i != "Aktion") and (i != "schluessel") and (i != "submitbutton"):
             formdict[i] = cgiformular[i].value
             formdict[i] = string.strip(formdict[i])
             # Spaces davor und danach weg (aus Formulareingabe)
             mobj = self.datumsform.search(formdict[i])
             if mobj is not None:
                formdict[i] = mobj.group(4)+"-"+mobj.group(3)+"-"+mobj.group(2)
                # Hier werden die Datumseingaben im Format TT.MM.JJJJ in das
                # MySQL-Format JJJJ-MM-TT umgewandelt.
                # Achtung, group(1) wrde den gesamten Treffer wiedergeben,
                # nicht ein Einzelteil!
      return formdict,mzliste

# Achtung, Test: alte Cookie-Methode wieder eingefhrt

   def cookiePruefen(self,flag,loginaktion,cookieaktion,env):
      if flag == cookieaktion:
         # Diese Aktion mu in jedem Fall angesprungen werden nach dem Login:
         return (flag,"")
      elif env.has_key("HTTP_COOKIE"):
         c = Cookie.SimpleCookie()
         c.load(env["HTTP_COOKIE"])
         if c:
            # Diese Prfung ist ntig, weil aus unerfindlichen Grnden - wenn der Skript
            # im Server-Proze luft - ggf. eine leere Umgebungsvariable "HTTP_COOKIE" existiert.
            cookie = c["name"].value
            return (flag,cookie)
         else:
            # ein leeres Cookie fhrt auch zum Login s.o.:
            return (loginaktion,"")         
      else:
         # kein Cookie als Umgebungsvariable vorhanden:
         return (loginaktion,"")

 ##  def cookiePruefen(self,flag,loginaktion,cookieaktion,env):
##      if verwaltungMainServer.einzelplatz != "ja":
##         print "verwaltungMainUtilities.cookiePruefen: Einzelplatz-Version flschlich aufgerufen!"
##         return 0
##      # eine neue Funktion fr die Einzelplatzversion, die "Cookies" auf der Festplatte speichert
##      statewerkzeug = state.State("einzelplatz")
##      # der Username ist hartcodiert - keine Optimallsung. Vgl. verwaltungMainServer, Funktion CookieGesetzt.
##      if flag == cookieaktion:
##         # Diese Aktion mu in jedem Fall angesprungen werden nach dem Login:
##         return (flag,"")
##      try:
##         cookie = statewerkzeug.variableHolen("Cookie")
##         return (flag,cookie)
##      except:
##         # kein Cookie als Umgebungsvariable vorhanden:
##         return (loginaktion,"")


