#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import htmlutilities
import sys
import re
import string
import sortieren
import urllib
import types
import baukontomysql
import gemeindekarteiweb
import kontenplan
import optionen

primaerkartei = 'Kontonummer'

class KontenplanWeb(gemeindekarteiweb.GemeindeverwaltungWeb):

    def __init__(self,MysqlDatenbank,Buchungsjahr,dictarray,schaltzentrale,alleSpalten,schluessel=None,datumumwandeln="ja"):
        self.optionswerkzeug = optionen.Optionen(MysqlDatenbank,buchungsjahr=Buchungsjahr)
        self.optionsfelder = self.optionswerkzeug.kontenplan_optionsfelder()
        self.Buchungsjahr = Buchungsjahr
        gemeindekarteiweb.GemeindeverwaltungWeb.__init__(self,dictarray,schaltzentrale,alleSpalten,schluessel)

    def datensatzkurz(self):
        matrix = []
        for i in self.dictarray:
            tempmatrix = ["%s: %s" % (i["Kontonummer"],i["Kontoname"])]
            tempmatrix.append( self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[primaerkartei],'Aktion':'KontoAnzeigen'},"Alles/ndern"))
            tempmatrix.append( self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[primaerkartei],'Aktion':'KontoLoeschenPruefen'},"Lschen"))
            matrix.append(tempmatrix)
        return self.htmlwerkzeug.tabelleMitInhalt(matrix,border="1")

    def aenderungsformular(self,aktion="KontenplanAenderungenTesten"):
        return gemeindekarteiweb.GemeindeverwaltungWeb.aenderungsformular(self,optionsfelder=self.optionsfelder,aktion=aktion,skript=self.schaltzentrale,submit="Neueintrge/nderungen prfen")

    def aenderungsvergleich(self,neueintrag="nein"):
        """berschreibt die entsprechende Funktion in der Superklasse. Beachte die
        andere Art und Anzahl der Funktionsparameter!"""
        zurueck_link = ""
        bestaetigen_link = "KontenplanAenderungenDurchfuehren"
        if neueintrag == "ja":
            zurueck_link = "KontenplanLoeschenDurchfuehren"
        else:
            zurueck_link = "KontoAnzeigen"
        return gemeindekarteiweb.GemeindeverwaltungWeb.aenderungsvergleich(self,bestaetigen_link,zurueck_link)
                               

    def loeschenBestaetigen(self):
        print """<body bgcolor="#FF1100" >"""
        i = self.dictarray[0]
        print "<H4>Konto %s: %s wird endgltig gelscht.</H4>" % (i["Kontonummer"],i["Kontoname"])
        if i["Hauptkonto"] == i["Kontonummer"]:
            print "<H4>Achtung, das zu lschende Konto ist ein Hauptkonto!</H4>"
        smartlink1 = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[primaerkartei],'Aktion':'KontenplanLoeschenDurchfuehren'},"Endgltiges Lschen besttigen!")
        smartlink2 = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[primaerkartei],'Aktion':'KontenplanUebersicht'},"Nicht lschen!")
        print """<p>%s<p><H3>%s</H3>""" % (smartlink1,smartlink2)

        
