-- MySQL dump 8.21
--
-- Host: localhost    Database: musterkartei
---------------------------------------------------------
-- Server version	3.23.49-log

--
-- Table structure for table 'abkuerzungen'
--

drop database if exists musterkartei;
create database musterkartei;
use musterkartei;

DROP TABLE IF EXISTS abkuerzungen;
CREATE TABLE abkuerzungen (
  Abkuerzung varchar(255) default '-',
  Bedeutung varchar(255) default '-',
  LfdNummer int(11) NOT NULL auto_increment,
  LetzteAenderung timestamp(14) NOT NULL,
  PRIMARY KEY  (LfdNummer)
) TYPE=MyISAM;

--
-- Dumping data for table 'abkuerzungen'
--


INSERT INTO abkuerzungen VALUES ('LD','Laiendelegierter',1,20040218183108);
INSERT INTO abkuerzungen VALUES ('A-Chr.Erz','Ausschu fr christliche Erziehung',3,20040218165607);
INSERT INTO abkuerzungen VALUES ('A-Kgl','Ausschu fr Kirchengliedschaft',4,20040218165718);
INSERT INTO abkuerzungen VALUES ('Diak','Diakonieauschu',5,20040218165900);
INSERT INTO abkuerzungen VALUES ('BK','Bezirkskonferenz',6,20040218165924);
INSERT INTO abkuerzungen VALUES ('GV Eib','Gemeindevorstand Eibenstock',7,20040218165946);
INSERT INTO abkuerzungen VALUES ('GV Clf','Gemeindevorstand Carlsfeld',8,20040218170119);
INSERT INTO abkuerzungen VALUES ('LP','Leitender Pastor',9,20040218183220);
INSERT INTO abkuerzungen VALUES ('A-ZGP','Ausschu fr Zusammenarbeit von Gemeinde und Pastor',10,20040218183635);
INSERT INTO abkuerzungen VALUES ('A-KE','Bauausschu',11,20040218183714);
INSERT INTO abkuerzungen VALUES ('A-KH','Haushaltsausschu',12,20040218183736);
INSERT INTO abkuerzungen VALUES ('VSA','Vorschlagsausschu',13,20040218183758);
INSERT INTO abkuerzungen VALUES ('Verw','Verwalter',15,20040218183849);
INSERT INTO abkuerzungen VALUES ('Pred','Predigtdienst',16,20040218183906);
INSERT INTO abkuerzungen VALUES ('Ggl','Gemeindegruppenleiter',17,20040218183922);
INSERT INTO abkuerzungen VALUES ('PosLeiter Clf','Posaunenchorleiter Carlsfeld',18,20040218183956);
INSERT INTO abkuerzungen VALUES ('Chorleiter Clf','Chorleiter Carlsfeld',19,20040218184159);
INSERT INTO abkuerzungen VALUES ('Seniorenkreis','Seniorenkreis',20,20040218184235);
INSERT INTO abkuerzungen VALUES ('Orgel','Orgeldienst',21,20040218184543);
INSERT INTO abkuerzungen VALUES ('G 1','Gemeindegruppe 1',22,20040218184709);
INSERT INTO abkuerzungen VALUES ('G 2','Gemeindegruppe 2',23,20040218184722);
INSERT INTO abkuerzungen VALUES ('G 3','Gemeindegruppe 3',24,20040218184733);
INSERT INTO abkuerzungen VALUES ('G 4','Gemeindegruppe 4',25,20040218184752);
INSERT INTO abkuerzungen VALUES ('G 5','Gemeindegruppe 5',26,20040218184804);
INSERT INTO abkuerzungen VALUES ('stellvLaie','Laiendelegierter (stellv.)',27,20040219090426);

--
-- Table structure for table 'baukontoneu2004'
--

DROP TABLE IF EXISTS baukontoneu2004;
CREATE TABLE baukontoneu2004 (
  Buchungsnummer int(11) NOT NULL auto_increment,
  Belegnummer varchar(30) default NULL,
  Belegdatum date NOT NULL default '0000-00-00',
  Buchungsdatum timestamp(14) NOT NULL,
  BearbeitetVon varchar(255) default '-',
  Buchungstext varchar(100) NOT NULL default '-',
  Bemerkungen varchar(255) default '-',
  Gemeinde varchar(100) default '-',
  Grundstueck varchar(100) default '-',
  MZ int(11) default '0',
  Spendername varchar(255) default '-',
  Squittung_noetig varchar(100) default 'nein',
  Spendenzweck varchar(255) default '-',
  Squittung_erstellt varchar(20) default 'nein',
  Sollkonto_1 varchar(20) default '-',
  BetragSoll_1 decimal(11,2) default '0.00',
  Sollkonto_2 varchar(20) default '-',
  BetragSoll_2 decimal(11,2) default '0.00',
  Sollkonto_3 varchar(20) default '-',
  BetragSoll_3 decimal(11,2) default '0.00',
  Habenkonto_1 varchar(20) default '-',
  BetragHaben_1 decimal(11,2) default '0.00',
  Habenkonto_2 varchar(20) default '-',
  BetragHaben_2 decimal(11,2) default '0.00',
  Habenkonto_3 varchar(20) default '-',
  BetragHaben_3 decimal(11,2) default '0.00',
  Stornonummer int(11) default '0',
  PRIMARY KEY  (Buchungsnummer)
) TYPE=MyISAM;

--
-- Dumping data for table 'baukontoneu2004'
--


INSERT INTO baukontoneu2004 VALUES (2,'2004-01-02-2-musterkartei2004','2004-01-02',20040221152902,'-','Ganz groe Spende','-','Eibenstock','-',2,'Mustermann, Martha','kirchlich','-','nein','41011',20000.00,'-',0.00,'-',0.00,'3052',20000.00,'-',0.00,'-',0.00,0);
INSERT INTO baukontoneu2004 VALUES (4,'2004-04-20-4-musterkartei2004','2004-04-20',20040224095638,'-','Monatsbeitrag April','-','Eibenstock','-',1,'Mustermann, Max','kirchlich','-','nein','41021',60.00,'-',0.00,'-',0.00,'301',60.00,'-',0.00,'-',0.00,0);

--
-- Table structure for table 'baukontoneu_kontenplan2004'
--

DROP TABLE IF EXISTS baukontoneu_kontenplan2004;
CREATE TABLE baukontoneu_kontenplan2004 (
  Kontonummer varchar(10) NOT NULL default '',
  Hauptkonto varchar(10) NOT NULL default '',
  Kontoname varchar(255) NOT NULL default '',
  Direktbuchung varchar(5) default 'nein',
  GemeindeNoetig varchar(5) default 'nein',
  MZNoetig varchar(5) default 'nein',
  GrundstueckNoetig varchar(5) default 'nein',
  SollMoeglich varchar(5) default 'nein',
  HabenMoeglich varchar(5) default 'nein',
  PRIMARY KEY  (Kontonummer)
) TYPE=MyISAM;

--
-- Dumping data for table 'baukontoneu_kontenplan2004'
--


INSERT INTO baukontoneu_kontenplan2004 VALUES ('301','301','Monatsbeitrge','ja','ja','ja','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('302','302','Kollekten','ja','ja','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('303','303','Sonderopfer','ja','ja','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('304','304','Spenden, allgemein','ja','ja','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('305','305','Spenden, zweckbestimmt fr Bezirksprojekte','ja','ja','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('3051','305','Bauopfer (Gemeinden)','ja','ja','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('3052','305','Bauopfer (Personen)','ja','ja','ja','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('307','307','Evangelisation','ja','nein','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('308','308','Gemeindediakonie','ja','nein','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('309','309','Arbeitskreise','ja','nein','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('310','310','Von kirchlichen Liegenschaften','ja','nein','nein','ja','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('3101','310','Kaltmieten','ja','nein','nein','ja','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('3102','310','Grundstcksveruerung','ja','nein','nein','ja','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('3103','310','Sonstige Einnahmen (Grundstcke)','ja','nein','nein','ja','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('3104','310','Durchlaufende Umstze (Nebenkosten)','ja','nein','nein','ja','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('312','312','Vermchtnisse','ja','nein','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('313','313','Sonstige Einnahmen','ja','nein','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('351','351','Umlage','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('352','352','Bewirtschaftungskosten','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('353','353','Inventarversicherung','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('354','354','Vergtungen','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('355','355','Verwaltungskosten, Auslagenersatz','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('356','356','Fahrtkosten','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('357','357','Anschaffung und Instandhaltung von Gert','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('365','365','Wohlttigkeit','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('367','367','Evangelisation','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('368','368','Gemeindediakonie','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('369','369','Arbeitskreise','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('370','370','Fr kirchliche Liegenschaften','ja','nein','nein','ja','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('3701','370','Zinsen allgemein','ja','nein','nein','ja','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('3702','370','Instandhaltung','ja','nein','nein','ja','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('3703','370','Neubauten, Grundstckserwerb','ja','nein','nein','ja','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('3704','370','Steuern','ja','nein','nein','ja','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('3705','370','Grundstcksverwaltung','ja','nein','nein','ja','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('3706','370','Sonstige Ausgaben (Grundstcke)','ja','nein','nein','ja','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('3707','370','Durchlaufende Umstze (Nebenkosten)','ja','nein','nein','ja','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('372','372','Grere Anschaffungen','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('373','373','Sonstige Ausgaben','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('380','380','Weltmission','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('381','381','EmK-Nchstenhilfe','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('382','382','Brot fr die Welt','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('383','383','Konferenz-Kollekten','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('384','384','Sonstige Durchlaufposten','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('385','385','Mildttige Spenden','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('386','386','Konferenzfinanzhilfe','ja','nein','nein','nein','ja','nein');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('401','401','Kassensaldo (01.01.)','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('402','402','Rcklagen (01.01.)','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('403','403','Darlehen (01.01.)','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('410','410','Kassensaldo (31.12.)','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('41011','410','Barkasse (Pastor)','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('41012','410','Baukasse (bar)','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('41021','410','Gemeindekonto','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('41022','410','Baukonto','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('4103','410','Kirchenbaukasse','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('4104','410','Verrechnungskonto Bank/Kasse','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('4105','410','Durchlaufende Posten','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('4106','410','Kassen der Arbeitskreise','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('4108','410','Aktive Rechnungsabgrenzung','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('4109','410','Passive Rechnungsabgrenzung','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('420','420','Rcklagen (31.12.)','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('430','430','Darlehen (31.12.)','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('4301','430','Darlehen (kirchl. Stellen)','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('4302','430','Darlehen (Kreditinstitute/Bausparkassen)','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('4303','430','Darlehen (staatl. Stellen)','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('4304','430','Darlehen (Privatpersonen)','ja','nein','nein','nein','ja','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('320','320','Weltmission','ja','nein','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('321','321','EmK-Nchstenhilfe','ja','nein','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('322','322','Brot fr die Welt','ja','nein','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('323','323','Konferenz-Kollekten','ja','nein','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('324','324','Sonstige Durchlaufposten','ja','nein','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('325','325','Mildttige Spenden','ja','nein','nein','nein','nein','ja');
INSERT INTO baukontoneu_kontenplan2004 VALUES ('326','326','Konferenzfinanzhilfe','ja','nein','nein','nein','nein','ja');

--
-- Table structure for table 'baukontoneu_vorlagen2004'
--

DROP TABLE IF EXISTS baukontoneu_vorlagen2004;
CREATE TABLE baukontoneu_vorlagen2004 (
  Buchungsnummer int(11) NOT NULL auto_increment,
  Belegnummer varchar(30) default NULL,
  Belegdatum date NOT NULL default '0000-00-00',
  Buchungsdatum timestamp(14) NOT NULL,
  BearbeitetVon varchar(255) default '-',
  Buchungstext varchar(100) NOT NULL default '-',
  Bemerkungen varchar(255) default '-',
  Gemeinde varchar(100) default '-',
  Grundstueck varchar(100) default '-',
  MZ int(11) default '0',
  Spendername varchar(255) default '-',
  Squittung_noetig varchar(100) default 'nein',
  Spendenzweck varchar(255) default '-',
  Squittung_erstellt varchar(20) default 'nein',
  Sollkonto_1 varchar(20) default '-',
  BetragSoll_1 decimal(11,2) default '0.00',
  Sollkonto_2 varchar(20) default '-',
  BetragSoll_2 decimal(11,2) default '0.00',
  Sollkonto_3 varchar(20) default '-',
  BetragSoll_3 decimal(11,2) default '0.00',
  Habenkonto_1 varchar(20) default '-',
  BetragHaben_1 decimal(11,2) default '0.00',
  Habenkonto_2 varchar(20) default '-',
  BetragHaben_2 decimal(11,2) default '0.00',
  Habenkonto_3 varchar(20) default '-',
  BetragHaben_3 decimal(11,2) default '0.00',
  Stornonummer int(11) default '0',
  PRIMARY KEY  (Buchungsnummer)
) TYPE=MyISAM;

--
-- Dumping data for table 'baukontoneu_vorlagen2004'
--


INSERT INTO baukontoneu_vorlagen2004 VALUES (1,NULL,'0000-00-00',20040221152914,'-','Ganz groe Spende','-','Eibenstock','-',2,'Mustermann, Martha','kirch','-','nein','41011',20000.00,'-',0.00,'-',0.00,'3052',20000.00,'-',0.00,'-',0.00,0);

--
-- Table structure for table 'gemeindekartei'
--

DROP TABLE IF EXISTS gemeindekartei;
CREATE TABLE gemeindekartei (
  Nachname varchar(60) default '-',
  Vorname varchar(60) default '-',
  Strasse varchar(70) default '-',
  Postleitzahl varchar(10) default '-',
  Wohnort varchar(60) default '-',
  Gemeinde varchar(60) default '-',
  Geburtstag date default '0000-00-00',
  geborenIn varchar(100) default '-',
  Telefon varchar(80) default '-',
  Fax varchar(255) default '-',
  EMail varchar(255) default '-',
  Kirchenbuch varchar(10) default '-',
  Status varchar(60) default '-',
  getauft varchar(60) default '-',
  getauftIn varchar(100) default '-',
  taufendeKirche varchar(100) default '-',
  eingesegnet varchar(60) default '-',
  getraut varchar(30) default '-',
  aufgenommen varchar(30) default '-',
  Gemeindegruppe varchar(30) default '-',
  Verantwortung varchar(255) default '-',
  Mitarbeit varchar(50) default '-',
  Geburtsname varchar(60) default '-',
  Familienstand varchar(10) default '-',
  Geschlecht char(2) default '-',
  Bemerkungen text,
  Spickzettel text,
  MZ int(11) NOT NULL auto_increment,
  abgegangen varchar(4) default 'nein',
  Zugangsdatum date default '0000-00-00',
  Zugangsgrund varchar(100) default '-',
  UeberweisungVon varchar(100) default '-',
  Abgangsdatum date default '0000-00-00',
  Abgangsgrund varchar(100) default '-',
  UeberweisungNach varchar(100) default '-',
  LetzteAenderung timestamp(14) NOT NULL,
  BearbeitetVon varchar(255) default '-',
  geprueft varchar(4) default 'ja',
  PRIMARY KEY  (MZ)
) TYPE=MyISAM;

--
-- Dumping data for table 'gemeindekartei'
--


INSERT INTO gemeindekartei VALUES ('Mustermann','Max','Musterstrae 5','08309','Eibenstock','Eibenstock','1925-05-25','-','112233','-','-','KG001','Kirchenglied','-','-','-','-','-','-','G 5','BK','-','-','-','ml','zu Familie Mller','krank seit Januar - besuchen!',1,'nein','0000-00-00','-','-','0000-00-00','-','-',20040221152154,'-','ja');
INSERT INTO gemeindekartei VALUES ('Mustermann','Martha','Musterstrae 5','08309','Eibenstock','Eibenstock','1923-04-25','-','112233','-','-','KG002','Kirchenglied','-','-','-','-','-','-','G 5','GV Eib','-','-','-','wl','zu Familie Mller','-',2,'nein','0000-00-00','-','-','0000-00-00','-','-',20040221152354,'-','ja');

--
-- Table structure for table 'optionen2004'
--

DROP TABLE IF EXISTS optionen2004;
CREATE TABLE optionen2004 (
  Buchungsjahr varchar(5) NOT NULL default '2002',
  abgeschlossen varchar(5) NOT NULL default 'nein',
  Gemeinden text,
  Grundstuecke text,
  SQuittung_Konten varchar(255) default '-',
  Abk_Gemeindekartei varchar(255) default '-',
  Abk_Gesangbuch varchar(255) default '-',
  Sicherungsverzeichnis varchar(255) default NULL,
  Serienbriefverzeichnis varchar(255) default '-',
  Datenbankverzeichnis varchar(255) default NULL,
  Importdatei varchar(255) default '-',
  Einzelplatz varchar(5) default 'ja',
  Textverarbeitung varchar(255) default '-',
  EMailServer varchar(255) default 'mailto.btx.dtag.de',
  DruckAnzahl varchar(5) default '5',
  PRIMARY KEY  (Buchungsjahr)
) TYPE=MyISAM;

--
-- Dumping data for table 'optionen2004'
--


INSERT INTO optionen2004 VALUES ('2004','nein','Eibenstock Carlsfeld Wildenthal Steinbach','Eibenstock Carlsfeld Steinbach','301 302 3052','Gemeindegruppe Verantwortung Mitarbeit','-','heimatverzeichnis/Bezirksreiter/BezirksreiterSicherung','heimatverzeichnis/Bezirksreiter/BezirksreiterVorlagen','-','heimatverzeichnis/Bezirksreiter/Bezirksreiter/importmuster.txt','ja','heimatverzeichnis/OpenOffice.org1.0.2/soffice','mailto.btx.dtag.de','5');
INSERT INTO optionen2004 VALUES ('jetzt','nein',NULL,NULL,'-','-','-','-','-','-','-','ja','-','mailto.btx.dtag.de','-');

