#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import streamredirect
import MySQLdb
import MySQLdb.converters
import sys
import gemeindeverwaltung
import htmlutilities
import string
import datumutilities
import cgi
import urllib
import Cookie
import os
import gemeindekarteiweb
import baukontoweb
import optionenweb
import optionen
import re
import verwaltungMainUtilities
import statemysql
import state
import time
import kontenplan
import kontenplanweb
import update
# import gesangbuchweb
import abkuerzungenweb
import verschiedeneUtilities

import verwaltungMainObjekt

class verwaltungMainFunktion(verwaltungMainObjekt.verwaltungMainObjekt):
    """Die Objektklasse fr die FiBu (Nicht-Statistik-Funktionen)"""
    
    def __init__(self,einzelplatz="ja",kwargs=None):
        verwaltungMainObjekt.verwaltungMainObjekt.__init__(self,einzelplatz=einzelplatz,subclass_args=kwargs)

    def hallo(self):
        """Zum Testen"""
        print "<p>hallo<p>"

    def NeuesBuchungsjahrTesten(self):
        print self.htmlintro        
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        print """<body bgcolor="#FFEE00" >"""
        print """<H3>Diese Funktion erzeugt das neue Buchungsjahr %s fr Datenbank %s, aktuelles Buchungsjahr %s. Das bisherige Buchungsjahr wird danach unter "Optionen" als "abgeschlossen=ja" gekennzeichnet.</H3>""" % (int(self.Buchungsjahr)+1,self.Datenbank,self.Buchungsjahr)       
        print """<p><p><p><H3>Sind die alten Daten gesichert?</H3><p>"""
        smartlink1 =  htmlwerkzeug.smartlink(self.schaltzentrale,{'Aktion':'NeuesBuchungsjahrAusfuehren'},"Ja!")
        smartlink2 =  htmlwerkzeug.smartlink(self.schaltzentrale,{'Aktion':'DatenSichern'},"Nein!")
        print """%s<p><H3>%s</H3>""" % (smartlink1,smartlink2)

    def NeuesBuchungsjahrAusfuehren(self):
        print self.htmlintro
        optionswerkzeug = gemeindeverwaltung.OptionenBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        test = optionswerkzeug.neuesBuchungsjahr()
        if test:
            print """<H3>Neues Buchungsjahr %s fr Datenbank %s erfolgreich erstellt!</H3>""" % (int(self.Buchungsjahr)+1,self.Datenbank)
            print """Sie k&ouml;nnen sich jetzt dort einloggen. <br>Passen Sie Optionen, Vorlagen und Kontenplan noch nach Ihren Wnschen an - sie wurden aus dem alten Buchungsjahr bernommen!"""
        else:
            print """<H3>Kein neues Buchungsjahr erstellt!</H3>"""

    def BaukontoBuchungsformular(self):
        print self.htmlintro
        baukonto = gemeindeverwaltung.BaukontoBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        leerdict = baukonto.holeLeerenEintrag()
        if self.flag == "BaukontoSpendeBuchen":
            leerdict.update(baukonto.spendername(self.schluessel))
        if self.flag == "BaukontoMonatsbeitragBuchen":
            leerdict = baukonto.letzterMonatsbeitrag(self.schluessel)       
        if self.flag == "BaukontoVorlageUebernehmen":
           leerdict = baukonto.inVorlagenHolen(self.schluessel)
        dictarray = [leerdict]
        webarray = baukontoweb.BaukontoWeb(self.MysqlDatenbank,self.Buchungsjahr,dictarray,self.schaltzentrale,baukonto.alleSpalten())
        webarray.kontennamenVollstaendig()
        print webarray.aenderungsformular()

    def BaukontoSpendeBuchen(self):
        self.BaukontoBuchungsformular()

    def BaukontoVorlageUebernehmen(self):
        self.BaukontoBuchungsformular()

    def BaukontoMonatsbeitragBuchen(self):
        self.BaukontoBuchungsformular()

    def BaukontoBuchungTesten(self):
        baukonto = gemeindeverwaltung.BaukontoBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        print self.htmlintro
        leerdict = baukonto.holeLeerenEintrag()
        leerdict.update(self.formdict)
        # *** s.u.!!!
        baukonto.betragsartPruefen(htmlwerkzeug.kontennamenUmwandeln(leerdict))
        print "<H3>Noch nderungen eintragen?</H3>"
        dictarray = [leerdict]
        # *** an webarray mssen die vollen, nicht umgewandelten Kontonamen
        # *** bergeben werden!
        webarray = baukontoweb.BaukontoWeb(self.MysqlDatenbank,self.Buchungsjahr,dictarray,self.schaltzentrale,baukonto.alleSpalten())
        print webarray.aenderungsformular(aktion="BaukontoBuchungDurchfuehren",submit="Buchen!")   
    
    def BaukontoBuchungDurchfuehren(self):
        print self.htmlintro
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        baukonto = gemeindeverwaltung.BaukontoBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        neudict = htmlwerkzeug.kontennamenUmwandeln(self.formdict)
        # von "302: xxx" bleibt nur "302"
        neubuch = baukonto.neuerEintrag(neudict)
        if neubuch != 0:
            # Buchung erfolgreich?
            print "<H3>Die Buchung wurde durchgefhrt:</H3>"
            dictarray= baukonto.schluesselSuchen(neubuch)
            webarray = baukontoweb.BaukontoWeb(self.MysqlDatenbank,self.Buchungsjahr,dictarray,self.schaltzentrale,baukonto.alleSpalten())
            print webarray.buchungsanzeige()
            print  """<H3>Notieren Sie die Belegnummer auf dem Beleg: %s</H3>""" % dictarray[0]["Belegnummer"]
            smartlink = htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': "%s" % neubuch, 'Aktion': 'LoeschenOhneStorno'},"Lschen!")
            print """<p><p>Sollten Sie eine Fehleingabe bemerkt haben, ist jetzt die letzte Mglichkeit zum Lschen ohne formelles Storno:<p><b>%s</b>""" % smartlink
        else:
            print "<H3>Die Buchung konnte nicht durchgefhrt werden!</H3>"

    def LoeschenOhneStorno(self):
        print self.htmlintro
        baukonto = gemeindeverwaltung.BaukontoBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        baukonto.eintragLoeschen(self.schluessel)
        print """<H3>Neue Buchung Nr. %s wurde endgltig gelscht (nicht: storniert)!</H3>""" % self.schluessel
    
    def BaukontoGesamtliste(self):
        print self.htmlintro
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        baukonto = gemeindeverwaltung.BaukontoBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        dictarray = baukonto.sortierteListe("Belegdatum")
        webarray = baukontoweb.BaukontoWeb(self.MysqlDatenbank,self.Buchungsjahr,dictarray,self.schaltzentrale,baukonto.alleSpalten())
        print webarray.datensatzkurz()
        #summekonto = baukonto.summeBaukonto()["SollMinusHaben"]
        #summebar = baukonto.summeBaukasseBar()["SollMinusHaben"]
        #print """<p><b>Summe Baukonto: %.2f EUR - Summe Baukasse(Bar) %.2f EUR</b>""" % (summekonto,summebar)
   
    def BaukontoBuchungAnzeigen(self):
        print self.htmlintro
        dictarray = []
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        baukonto = gemeindeverwaltung.BaukontoBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        mitLinks = "nein"
        if self.flag == "BaukontoBuchungAnzeigen":
           dictarray = baukonto.schluesselSuchen(self.schluessel)
           mitLinks = "ja"
           # die Links fr Vorlage und Storno sollen angezeigt werden, wenn keine Vorlage
        else:
           dictarray = [baukonto.inVorlagenHolen(self.schluessel)]
        webarray = baukontoweb.BaukontoWeb(self.MysqlDatenbank,self.Buchungsjahr,dictarray,self.schaltzentrale,baukonto.alleSpalten(),schluessel=self.schluessel)
        print webarray.buchungsanzeige(mitLinks=mitLinks)

    def BaukontoVorlageAnzeigen(self):
        self.BaukontoBuchungAnzeigen()
    
    def BaukontoVorlageLoeschen(self):
        baukonto = gemeindeverwaltung.BaukontoBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        baukonto.inVorlagenLoeschen(self.schluessel)
        self.BaukontoVorlagenGesamtliste() # zur Anzeige
    
    def BaukontoAlsVorlageSpeichern(self):
        baukonto = gemeindeverwaltung.BaukontoBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        baukonto.inVorlagenKopieren(self.schluessel)
        self.BaukontoVorlagenGesamtliste() # zur Anzeige 
    
    def BaukontoVorlagenGesamtliste(self):
        print self.htmlintro
        print "<H3>Vorlagen</H3>"
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        baukonto = gemeindeverwaltung.BaukontoBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        dictarray = baukonto.alleVorlagenHolen()
        webarray = baukontoweb.BaukontoWeb(self.MysqlDatenbank,self.Buchungsjahr,dictarray,self.schaltzentrale,baukonto.alleSpalten())
        print webarray.datensatzkurz(vorlage="ja")
    
    def BaukontoStornoPruefen(self):
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        print self.htmlintro
        print """<body bgcolor="#FF1100" >"""
        print "<H3>Wirklich Buchung stornieren?</H3>"
        smartlink1 = htmlwerkzeug.smartlink(self.schaltzentrale,{'Aktion':'BaukontoBuchungStornieren','schluessel': self.schluessel},"Stornieren!")
        smartlink2 =  htmlwerkzeug.smartlink(self.schaltzentrale,{'Aktion':'BaukontoGesamtliste'},"Zurck!")
        print """<p>%s""" % smartlink1
        print """<p><H3>%s</H3>""" % smartlink2
    
    def BaukontoBuchungStornieren(self):
        print self.htmlintro
        # verschiedeneUtilities.gibLaut("Lschen")
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        baukonto = gemeindeverwaltung.BaukontoBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        #print neudict
        neubuch = baukonto.storno(self.schluessel)
        if neubuch != 0:
           # Buchung erfolgreich?
           print "<H3>Die Buchung wurde durchgefhrt:</H3>"
           dictarray= baukonto.schluesselSuchen(neubuch)
           webarray = baukontoweb.BaukontoWeb(self.MysqlDatenbank,self.Buchungsjahr,dictarray,self.schaltzentrale,baukonto.alleSpalten())
           print webarray.buchungsanzeige()
           print  """<H3>Notieren Sie die Belegnummer auf dem Beleg: %s</H3>""" % dictarray[0]["Belegnummer"]
        else:
           print "<H3>Die Buchung konnte nicht durchgefhrt werden!</H3>"

        


class verwaltungMainFunktionEinzelplatz(verwaltungMainFunktion):
    def __init__(self,einzelplatz,kwargs):
        verwaltungMainFunktion.__init__(self,einzelplatz,kwargs=kwargs)



def objekt_holen(einzelplatz="ja",**kwargs):
    if einzelplatz == "ja":
        return verwaltungMainFunktionEinzelplatz(einzelplatz,kwargs)

if __name__ == "__main__":
    test= objekt_holen(einzelplatz="ja",Buchungsjahr="2003")
    print test
    print test.Buchungsjahr
